'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _ComponentStyle = require('../models/ComponentStyle');

var _ComponentStyle2 = _interopRequireDefault(_ComponentStyle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* todo: replace any with React.Component */
var element = function element(tagName, rules) {
  var styleRoot = new _ComponentStyle2.default(rules);
  /* Return a stateless functional component that simply renders
   * a HTML element with our styles applied. */
  var component = function component(props) {
    return (0, _react.createElement)(tagName, Object.assign({}, props, {
      className: [props.className, styleRoot.injectStyles([props])].join(' ')
    }));
  };
  component.displayName = 'Styled(' + (tagName.displayName || tagName) + ')';
  return component;
};

exports.default = element;
module.exports = exports['default'];